#!/usr/bin/env node
"use strict";

var _commander = require("commander");
var _convertSingle = require("./cli/convert-single");
var _convertFolder = require("./cli/convert-folder");
var program = new _commander.Command();
program
// eslint-disable-next-line @typescript-eslint/no-var-requires
.version(require('../package.json').version).description('Vue Class Component to Composition API Converter').usage('<command> [options]');
program.command('single <filepath>').description('Convert a single Vue file to Composition API').option('-v, --view', 'Preview changes in the editor').option('-p --pluginsDir <DIR_PATH>', 'Path to directory with plugins').action(function (filepath, options) {
  (0, _convertSingle.convertSingleFile)(filepath, options);
});
program.command('folder <filePath>').description('Convert folder vue files to Composition API').option('-p --pluginsDir <DIR_PATH>', 'Path to directory with plugins').action(function (filepath) {
  (0, _convertFolder.convertFolder)(filepath);
});
program.parse(process.argv);