"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.generateVue = void 0;
var _utils = require("./utils");
var generateVue = exports.generateVue = function generateVue(sfc, code) {
  var _sfc$template;
  var codeFormat = code.trim().replaceAll("//".concat(_utils.newLine), '');
  var content = (_sfc$template = sfc.template) !== null && _sfc$template !== void 0 && (_sfc$template = _sfc$template.content) !== null && _sfc$template !== void 0 && _sfc$template.trim() ? "<template>".concat(sfc.template.content.trim(), "</template>") : '';
  var rawCodeVue = "\n\n<script lang=\"ts\">".concat(codeFormat, "</script>");
  var styles = "\n\n".concat(sfc.styles.map(function (style) {
    var _style$attrs;
    return "<style ".concat((_style$attrs = style.attrs) !== null && _style$attrs !== void 0 && _style$attrs.lang ? "lang=\"".concat(style.attrs.lang, "\" ").concat(style.scoped ? ' scoped' : '') : '', ">").concat(style.content.trim(), "</style>");
  }).join('\n\t'));
  return content + rawCodeVue + styles;
};