"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isHasDecorator = exports.getDefaultNode = exports.getDecoratorArguments = exports.getComponentName = exports.getClassPropertiesByDecoratorName = exports.getBodyClass = exports.createShortHandProperty = void 0;
var t = _interopRequireWildcard(require("@babel/types"));
var _traverse = _interopRequireDefault(require("@babel/traverse"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
var getDefaultNode = exports.getDefaultNode = function getDefaultNode(ast) {
  var defaultNode = null;
  (0, _traverse["default"])(ast, {
    ExportDefaultDeclaration: function ExportDefaultDeclaration(path) {
      defaultNode = path;
    }
  });
  return defaultNode;
};

// Class name
var getComponentName = exports.getComponentName = function getComponentName(node) {
  if (t.isClassDeclaration(node.node.declaration)) {
    var decl = node.node.declaration;
    return t.objectProperty(t.identifier('name'), t.stringLiteral(decl.id.name));
  }
  return null;
};
var getDecoratorArguments = exports.getDecoratorArguments = function getDecoratorArguments(property) {
  if (!property.decorators) {
    return null;
  }
  var _property$decorators = _slicedToArray(property.decorators, 1),
    decorator = _property$decorators[0];
  if (!t.isCallExpression(decorator.expression)) {
    return null;
  }
  return decorator.expression.arguments;
};
var getBodyClass = exports.getBodyClass = function getBodyClass(node) {
  if (!t.isClassDeclaration(node.node.declaration)) {
    return null;
  }
  return node.node.declaration.body;
};

// @Prop
var isHasDecorator = exports.isHasDecorator = function isHasDecorator(property, decoratorName) {
  var _property$decorators2;
  if (!property.decorators || (property === null || property === void 0 || (_property$decorators2 = property.decorators) === null || _property$decorators2 === void 0 ? void 0 : _property$decorators2.length) === 0) {
    return false;
  }
  return property.decorators.some(function (decorator) {
    if (t.isIdentifier(decorator.expression)) {
      return decorator.expression.name === decoratorName;
    }
    if (!t.isCallExpression(decorator.expression) || !t.isIdentifier(decorator.expression.callee)) {
      return false;
    }
    // @Prop({ type: Object, required: true })
    return decorator.expression.callee.name === decoratorName;
  });
};
var getClassPropertiesByDecoratorName = exports.getClassPropertiesByDecoratorName = function getClassPropertiesByDecoratorName(node, decoratorName) {
  var body = getBodyClass(node);
  if (!body) {
    return [];
  }
  var properties = body.body.filter(function (n) {
    return t.isClassProperty(n);
  });
  if (!properties.length) {
    return [];
  }
  return properties.filter(function (n) {
    var _n$decorators;
    return (_n$decorators = n.decorators) === null || _n$decorators === void 0 ? void 0 : _n$decorators.length;
  }).filter(function (n) {
    return isHasDecorator(n, decoratorName);
  });
};
var createShortHandProperty = exports.createShortHandProperty = function createShortHandProperty(name) {
  return t.objectProperty(t.identifier(name), t.identifier(name), false, true);
};