"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.usePlugins = exports.definePlugin = exports.defaultPlugins = void 0;
var _store = _interopRequireDefault(require("./store"));
var t = _interopRequireWildcard(require("@babel/types"));
var _traverse = _interopRequireDefault(require("@babel/traverse"));
var _serverClientPlugin = require("./plugins/serverClientPlugin");
var _i18n = require("./plugins/i18n");
var _useRouter = require("./plugins/useRouter");
var _validate = require("./plugins/validate");
var _popup = require("./plugins/popup");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
var definePlugin = exports.definePlugin = function definePlugin(name, plugin) {
  _store["default"].registerPlugin(name, plugin);
  return plugin;
};
var usePlugins = exports.usePlugins = function usePlugins(ast) {
  var plugins = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  // Plugins
  var pluginParams = {
    ast: ast,
    t: t,
    traverse: _traverse["default"],
    store: _store["default"]
  };
  _store["default"].getPlugins().forEach(function (plugin) {
    return plugin(pluginParams);
  });
  plugins.forEach(function (plugin) {
    return plugin(pluginParams);
  });
};
var defaultPlugins = exports.defaultPlugins = [_serverClientPlugin.serverClientPlugin, _i18n.i18nPlugin, _useRouter.useRouterPlugin, _validate.useValidatePlugin, _popup.usePopupPlugin];