"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.i18nPlugin = void 0;
var _helpers = require("../helpers");
function _toConsumableArray(r) { return _arrayWithoutHoles(r) || _iterableToArray(r) || _unsupportedIterableToArray(r) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _iterableToArray(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithoutHoles(r) { if (Array.isArray(r)) return _arrayLikeToArray(r); }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
var i18nPlugin = exports.i18nPlugin = function i18nPlugin(_ref) {
  var ast = _ref.ast,
    t = _ref.t,
    traverse = _ref.traverse,
    store = _ref.store;
  var i18nContextKey = new Map([['$t', 't'], ['$d', 'd'], ['$tc', 'tc'], ['$te', 'te'], ['$n', 'n']]);
  var existKeys = new Set();

  // 1. replace this.$t() to t()
  traverse(ast, {
    MemberExpression: function MemberExpression(path) {
      if (t.isThisExpression(path.node.object) && t.isIdentifier(path.node.property)) {
        var propertyName = path.node.property.name;
        if (i18nContextKey.has(propertyName)) {
          path.replaceWith(t.identifier(i18nContextKey.get(propertyName)));
          existKeys.add(i18nContextKey.get(propertyName));
        }
      }
    }
  });
  if (existKeys.size === 0) {
    return;
  }
  var objectProperties = _toConsumableArray(existKeys.values()).map(function (key) {
    return (0, _helpers.createShortHandProperty)(key);
  });

  // 2. Add const {t, n} = useI18n(i18n);
  var i18n = t.variableDeclaration('const', [t.variableDeclarator(t.objectPattern(objectProperties), t.callExpression(t.identifier('useI18n'), [t.identifier('i18n')]))]);
  store.addBeforeSetupStatement('i18n', i18n);

  // 3. Add Import { useI18n } from 'vue-i18n';
  store.addImport('common/composables/use-i18n', 'useI18n');
};