"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.serverClientPlugin = void 0;
var serverClientPlugin = exports.serverClientPlugin = function serverClientPlugin(_ref) {
  var ast = _ref.ast,
    t = _ref.t,
    store = _ref.store,
    traverse = _ref.traverse;
  traverse(ast, {
    CallExpression: function CallExpression(path) {
      if (!path.node.arguments) {
        return;
      }
      var arg = path.node.arguments[0];
      if (!arg) {
        return;
      }
      if (!t.isIdentifier(arg)) {
        return;
      }
      var name = arg.name;
      if (!name.endsWith('Client')) {
        return;
      }
      var newExpression = t.callExpression(t.identifier('useServerClient'), [arg]);
      store.addImport('composables/use-server-client', 'useServerClient', true);
      path.replaceWith(newExpression);
      path.skip();
      if (!Array.isArray(path.container) && t.isClassProperty(path.container)) {
        if (t.isIdentifier(path.container.key)) {
          store.addExcludeRef(path.container.key.name);
        }
      }
    }
  });
};