"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useRouterPlugin = void 0;
var useRouterPlugin = exports.useRouterPlugin = function useRouterPlugin(_ref) {
  var ast = _ref.ast,
    t = _ref.t,
    traverse = _ref.traverse,
    store = _ref.store;
  var keys = new Map([['$route', {
    key: 'route',
    "import": {
      source: 'vue-router/composables',
      path: 'useRoute'
    }
  }], ['$router', {
    key: 'router',
    "import": {
      source: 'vue-router/composables',
      path: 'useRouter'
    }
  }]]);
  traverse(ast, {
    MemberExpression: function MemberExpression(path) {
      if (t.isThisExpression(path.node.object) && t.isIdentifier(path.node.property)) {
        var propertyName = path.node.property.name;
        if (keys.has(propertyName)) {
          var result = keys.get(propertyName);

          // 1. replace this.router to router
          path.replaceWith(t.identifier(result.key));

          // 2. Add Import { useRoute } from 'vue-router/composables';
          store.addImport(result["import"].source, result["import"].path);

          // 3. Add const router = useRouter()
          var declaration = t.variableDeclaration('const', [t.variableDeclarator(t.identifier(result.key), t.callExpression(t.identifier(result["import"].path), []))]);
          store.addBeforeSetupStatement(result["import"].path, declaration);
        }
      }
    }
  });
};