"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useValidatePlugin = void 0;
var _helpers = require("../helpers");
var useValidatePlugin = exports.useValidatePlugin = function useValidatePlugin(_ref) {
  var ast = _ref.ast,
    t = _ref.t,
    traverse = _ref.traverse,
    store = _ref.store;
  var names = [];
  var rules = [];
  traverse(ast, {
    Decorator: function Decorator(path) {
      if (t.isCallExpression(path.node.expression) && t.isIdentifier(path.node.expression.callee)) {
        var name = path.node.expression.callee.name;
        if (name === 'Validate') {
          if (t.isClassMethod(path.parent) || t.isClassProperty(path.parent)) {
            var nameProperty = path.parent.key.name;
            var arg = path.node.expression.arguments[0];
            if (t.isExpression(arg)) {
              rules.push(t.objectProperty(t.identifier(nameProperty), arg));
              names.push((0, _helpers.createShortHandProperty)(nameProperty));
            }
          }
        }
      }
    }
  });
  if (rules.length === 0) {
    return;
  }
  var $v = t.variableDeclaration('const', [t.variableDeclarator(t.identifier('$v'), t.callExpression(t.identifier('useVuelidate'), [t.objectExpression(rules), t.objectExpression(names)]))]);
  var statement = t.expressionStatement(t.callExpression(t.identifier('provide'), [t.stringLiteral('$v'), t.identifier('$v')]));
  store.addAfterSetupStatement('useVuelidate', $v);
  store.addAfterSetupStatement('provide$v', statement);
  store.addRef('$v');
};