"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getProps = void 0;
var t = _interopRequireWildcard(require("@babel/types"));
var _helpers = require("./helpers");
var _store = _interopRequireDefault(require("./store"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
function _toConsumableArray(r) { return _arrayWithoutHoles(r) || _iterableToArray(r) || _unsupportedIterableToArray(r) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _iterableToArray(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithoutHoles(r) { if (Array.isArray(r)) return _arrayLikeToArray(r); }
function _createForOfIteratorHelper(r, e) { var t = "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (!t) { if (Array.isArray(r) || (t = _unsupportedIterableToArray(r)) || e && r && "number" == typeof r.length) { t && (r = t); var _n = 0, F = function F() {}; return { s: F, n: function n() { return _n >= r.length ? { done: !0 } : { done: !1, value: r[_n++] }; }, e: function e(r) { throw r; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var o, a = !0, u = !1; return { s: function s() { t = t.call(r); }, n: function n() { var r = t.next(); return a = r.done, r; }, e: function e(r) { u = !0, o = r; }, f: function f() { try { a || null == t["return"] || t["return"](); } finally { if (u) throw o; } } }; }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
var store = _store["default"];
var createProp = function createProp(name, properties) {
  return t.objectProperty(t.identifier(name), t.objectExpression(properties.filter(function (n) {
    return !!n;
  })));
};
var requiredProperty = t.objectProperty(t.identifier('required'), t.booleanLiteral(true));
var createPropType = function createPropType(typeName, isArray) {
  // type: Object as PropType<INotificationModel>
  // type: Array as PropType<INotificationModel[]>
  var reference = t.tSTypeReference(t.identifier(typeName));
  var identifier = t.identifier(isArray ? 'Array' : 'Object');
  return t.objectProperty(t.identifier('type'), t.tsAsExpression(identifier, t.tsTypeReference(t.identifier('PropType'), t.tsTypeParameterInstantiation([isArray ? t.tsArrayType(reference) : reference]))));
};
var _getTypeName = function getTypeName(type) {
  if (t.isTSTypeReference(type) && t.isIdentifier(type.typeName)) {
    return type.typeName.name;
  }
  if (t.isTSArrayType(type)) {
    return _getTypeName(type.elementType);
  }
  return null;
};
var transformProp = function transformProp(property) {
  var propName = property.key.name;
  store.addPropName(propName);
  if (!t.isTSTypeAnnotation(property.typeAnnotation)) {
    return createProp(propName, [requiredProperty]);
  }
  var type = property.typeAnnotation.typeAnnotation;
  var results = new Map();
  var typeName = _getTypeName(type);
  if (t.isTSTypeReference(type)) {
    // type: Object as PropType<INotificationModel>
    results.set('type', createPropType(typeName, false));
  }
  if (t.isTSArrayType(type)) {
    // type: Array as PropType<INotificationModel[]>
    results.set('type', createPropType(typeName, true));
  }
  if (t.isTSStringKeyword(type)) {
    // type: String
    var prop = t.objectProperty(t.identifier('type'), t.identifier('String'));
    results.set('type', prop);
  }
  if (t.isTSBooleanKeyword(type)) {
    // type: Boolean
    var _prop = t.objectProperty(t.identifier('type'), t.identifier('Boolean'));
    results.set('type', _prop);
  }
  if (t.isTSNumberKeyword(type)) {
    // type: Number
    var _prop2 = t.objectProperty(t.identifier('type'), t.identifier('Number'));
    results.set('type', _prop2);
  }
  var args = (0, _helpers.getDecoratorArguments)(property);
  if (args && args.length > 0) {
    var arg = args[0];
    if (t.isObjectExpression(arg)) {
      var _iterator = _createForOfIteratorHelper(arg.properties),
        _step;
      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var _property = _step.value;
          if (t.isObjectProperty(_property) && t.isIdentifier(_property.key)) {
            if (!results.get(_property.key.name)) {
              results.set(_property.key.name, _property);
            }
          }
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }
    }
  }

  // TODO: get config options
  if (!results.get('default')) {
    results.set('required', requiredProperty);
  }
  return createProp(propName, _toConsumableArray(results.values()));
};
var getProps = exports.getProps = function getProps(node) {
  var classProperties = (0, _helpers.getClassPropertiesByDecoratorName)(node, 'Prop');
  var properties = _toConsumableArray(_store["default"].getProps().values());
  var _iterator2 = _createForOfIteratorHelper(classProperties),
    _step2;
  try {
    for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
      var property = _step2.value;
      var res = transformProp(property);
      if (res) {
        properties.push(res);
      }
    }
  } catch (err) {
    _iterator2.e(err);
  } finally {
    _iterator2.f();
  }
  if (properties.length === 0) {
    return null;
  }
  return t.objectProperty(t.identifier('props'), t.objectExpression(properties));
};