"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getMethods = void 0;
var t = _interopRequireWildcard(require("@babel/types"));
var _helpers = require("../helpers");
var _store = _interopRequireDefault(require("../store"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
function _createForOfIteratorHelper(r, e) { var t = "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (!t) { if (Array.isArray(r) || (t = _unsupportedIterableToArray(r)) || e && r && "number" == typeof r.length) { t && (r = t); var _n = 0, F = function F() {}; return { s: F, n: function n() { return _n >= r.length ? { done: !0 } : { done: !1, value: r[_n++] }; }, e: function e(r) { throw r; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var o, a = !0, u = !1; return { s: function s() { t = t.call(r); }, n: function n() { var r = t.next(); return a = r.done, r; }, e: function e(r) { u = !0, o = r; }, f: function f() { try { a || null == t["return"] || t["return"](); } finally { if (u) throw o; } } }; }
function _toConsumableArray(r) { return _arrayWithoutHoles(r) || _iterableToArray(r) || _unsupportedIterableToArray(r) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _iterableToArray(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithoutHoles(r) { if (Array.isArray(r)) return _arrayLikeToArray(r); }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
var legacyHooks = new Map([['beforeCreate', 'beforeCreate'], ['created', 'created']]);
var internalHooks = new Map([['beforeMount', 'onBeforeMount'], ['mounted', 'onMounted'], ['beforeDestroy', 'onBeforeUnmount'], ['destroyed', 'onUnmounted'], ['beforeUpdate', 'onBeforeUpdate'], ['updated', 'onUpdated'], ['activated', 'onActivated'], ['deactivated', 'onDeactivated'], ['render', 'onRender'], ['errorCaptured', 'onErrorCaptured'], ['serverPrefetch', 'onServerPrefetch']]);
var transformMethod = function transformMethod(node) {
  if (t.isIdentifier(node.key)) {
    var name = node.key.name;
    var body = node.body;
    var params = node.params.filter(function (n) {
      return t.isIdentifier(n) || t.isPattern(n) || t.isRestElement(n);
    });
    var expression = t.arrowFunctionExpression(_toConsumableArray(params), body, node.async);

    // beforeCreate
    if (legacyHooks.has(name)) {
      var legacyName = legacyHooks.get(name);
      var _result = t.variableDeclaration('const', [t.variableDeclarator(t.identifier(legacyHooks.get(name)), expression)]);
      _store["default"].addAfterSetupStatement(legacyName, t.expressionStatement(t.callExpression(t.identifier(legacyName), [])));
      return _result;
    }
    // mounted -> onMounted
    if (internalHooks.has(name)) {
      var newName = internalHooks.get(name);
      var _result2 = t.expressionStatement(t.callExpression(t.identifier(newName), [expression]));
      _store["default"].addImport('vue', newName);
      return _result2;
    }

    // other methods
    var result = t.variableDeclaration('const', [t.variableDeclarator(t.identifier(name), expression)]);
    _store["default"].addReturnStatement(name, t.objectProperty(t.identifier(name), t.identifier(name), false, true));
    return result;
  }
  return null;
};
var getMethods = exports.getMethods = function getMethods(node) {
  var body = (0, _helpers.getBodyClass)(node);
  if (!body) {
    return [];
  }
  var statements = [];
  var methods = body.body.filter(function (n) {
    return t.isClassMethod(n, {
      kind: 'method'
    });
  });
  var _iterator = _createForOfIteratorHelper(methods),
    _step;
  try {
    for (_iterator.s(); !(_step = _iterator.n()).done;) {
      var method = _step.value;
      var result = transformMethod(method);
      if (result) {
        statements.push(result);
      }
    }
  } catch (err) {
    _iterator.e(err);
  } finally {
    _iterator.f();
  }
  return statements;
};