"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.transformToRef = exports.savesRefNames = exports.saveRefName = exports.getRefs = void 0;
var t = _interopRequireWildcard(require("@babel/types"));
var _helpers = require("../helpers");
var _store = _interopRequireDefault(require("../store"));
var _traverse = _interopRequireDefault(require("@babel/traverse"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
function _createForOfIteratorHelper(r, e) { var t = "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (!t) { if (Array.isArray(r) || (t = _unsupportedIterableToArray(r)) || e && r && "number" == typeof r.length) { t && (r = t); var _n = 0, F = function F() {}; return { s: F, n: function n() { return _n >= r.length ? { done: !0 } : { done: !1, value: r[_n++] }; }, e: function e(r) { throw r; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var o, a = !0, u = !1; return { s: function s() { t = t.call(r); }, n: function n() { var r = t.next(); return a = r.done, r; }, e: function e(r) { u = !0, o = r; }, f: function f() { try { a || null == t["return"] || t["return"](); } finally { if (u) throw o; } } }; }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
var saveRefName = exports.saveRefName = function saveRefName(prop) {
  if ((0, _helpers.isHasDecorator)(prop, 'Prop')) {
    return;
  }
  if (!t.isIdentifier(prop.key)) {
    return;
  }
  var name = prop.key.name;
  _store["default"].addRef(name);
};
var savesRefNames = exports.savesRefNames = function savesRefNames(ast) {
  (0, _traverse["default"])(ast, {
    ClassProperty: function ClassProperty(path) {
      saveRefName(path.node);
    }
  });
};
var transformToRef = exports.transformToRef = function transformToRef(prop) {
  if ((0, _helpers.isHasDecorator)(prop, 'Prop')) {
    return null;
  }
  if (!t.isIdentifier(prop.key)) {
    return null;
  }
  var value = prop.value ? prop.value : t.nullLiteral();
  var getRef = function getRef() {
    if (prop.typeAnnotation && t.isTSTypeAnnotation(prop.typeAnnotation)) {
      var withType = t.tsInstantiationExpression(t.identifier('ref'), t.tsTypeParameterInstantiation([prop.typeAnnotation.typeAnnotation]));
      return t.callExpression(withType, [value]);
    }
    return t.callExpression(t.identifier('ref'), [value]);
  };
  var ref = getRef();
  var name = prop.key.name;
  _store["default"].addShortReturnStatementByName(name);
  if (_store["default"].hasExcludeRefsName(name)) {
    return t.variableDeclaration('const', [t.variableDeclarator(prop.key, value)]);
  }
  var res = t.variableDeclaration('const', [t.variableDeclarator(prop.key, ref)]);
  _store["default"].addRef(name);
  return res;
};
var getRefs = exports.getRefs = function getRefs(node) {
  var body = (0, _helpers.getBodyClass)(node);
  if (!body) {
    return [];
  }
  var properties = body.body.filter(function (n) {
    return t.isClassProperty(n);
  }).filter(function (n) {
    return !(0, _helpers.isHasDecorator)(n, 'Prop');
  });
  var declarations = [];
  var _iterator = _createForOfIteratorHelper(properties),
    _step;
  try {
    for (_iterator.s(); !(_step = _iterator.n()).done;) {
      var prop = _step.value;
      var res = transformToRef(prop);
      if (res) {
        declarations.push(res);
      }
    }
  } catch (err) {
    _iterator.e(err);
  } finally {
    _iterator.f();
  }
  return declarations;
};