"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.thisTransform = exports.replaceThis = void 0;
var t = _interopRequireWildcard(require("@babel/types"));
var _traverse = _interopRequireDefault(require("@babel/traverse"));
var _store = _interopRequireDefault(require("./store"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var thisTransform = exports.thisTransform = function thisTransform(path) {
  if (t.isThisExpression(path.node.object) && t.isIdentifier(path.node.property)) {
    var propertyName = path.node.property.name;
    var isProp = _store["default"].hasPropName(propertyName);

    // props
    if (isProp && propertyName) {
      _store["default"].setFlag('HAS_PROPS', true);
      var newExpression = t.memberExpression(t.identifier('props'), t.identifier(propertyName));
      path.replaceWith(newExpression);
      return;
    }
    if (propertyName) {
      // Replace this.someValue на someValue.value
      if (_store["default"].hasRefName(propertyName)) {
        var _newExpression = t.memberExpression(t.identifier(propertyName), t.identifier('value'));
        path.replaceWith(_newExpression);
      } else {
        var _newExpression2 = t.identifier(propertyName);
        path.replaceWith(_newExpression2);
      }
    }
  }
};
var replaceThis = exports.replaceThis = function replaceThis(ast) {
  (0, _traverse["default"])(ast, {
    MemberExpression: function MemberExpression(path) {
      thisTransform(path);
    }
  });
};