"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.transform = void 0;
var t = _interopRequireWildcard(require("@babel/types"));
var _thisTransform = require("./this-transform");
var _helpers = require("./helpers");
var _component = require("./component");
var _props = require("./props");
var _setup = require("./setup");
var _other = require("./other");
var _imports = require("./imports");
var _utils = require("./utils");
var _context = require("./setup/context");
var _refs = require("./setup/refs");
var _vue = require("./setup/vue");
var _ref2 = require("./setup/ref");
var _computed = require("./setup/computed");
var _methods = require("./setup/methods");
var _store = _interopRequireDefault(require("./store"));
var _plugins = require("./plugins");
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
function _toConsumableArray(r) { return _arrayWithoutHoles(r) || _iterableToArray(r) || _unsupportedIterableToArray(r) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _iterableToArray(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithoutHoles(r) { if (Array.isArray(r)) return _arrayLikeToArray(r); }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
var transform = exports.transform = function transform(ast, options) {
  var _ref = options !== null && options !== void 0 ? options : {},
    _ref$plugins = _ref.plugins,
    plugins = _ref$plugins === void 0 ? [] : _ref$plugins;
  // Before clear store
  _store["default"].clear();
  var node = (0, _helpers.getDefaultNode)(ast);
  // Plugins
  (0, _plugins.usePlugins)(ast, [].concat(_toConsumableArray(_plugins.defaultPlugins), _toConsumableArray(plugins)));
  var otherNodes = (0, _other.getOtherNodes)(ast);
  var componentName = (0, _helpers.getComponentName)(node);
  var componentOptions = (0, _component.getComponentOptions)(node);
  var props = (0, _props.getProps)(node);
  var refs = (0, _ref2.getRefs)(node);
  var computeds = (0, _computed.getComputeds)(node);
  var methods = (0, _methods.getMethods)(node);
  (0, _context.replaceContext)(ast);
  (0, _refs.replaceRefsToRef)(ast);
  (0, _vue.replaceVueHooks)(ast);

  // Replace this.
  (0, _thisTransform.replaceThis)(ast);
  var setup = (0, _setup.createSetup)([].concat(_toConsumableArray(refs), _toConsumableArray(computeds), _toConsumableArray(methods)));
  var properties = [componentName].concat(_toConsumableArray(componentOptions), [props, setup]).filter(function (n) {
    return !!n;
  });
  var defineComponent = t.exportDefaultDeclaration(t.callExpression(t.identifier('defineComponent'), [t.objectExpression(_toConsumableArray(properties))]));
  var imports = (0, _imports.getImportsNodes)(ast);
  var newAst = t.program([].concat(_toConsumableArray(imports), _toConsumableArray(otherNodes.map(_utils.wrapNewLineComment)), [(0, _utils.wrapNewLineComment)(defineComponent)]));
  return newAst;
};